# GeometryUpdater

#### new Cesium.GeometryUpdater(options)
DataSources/GeometryUpdater.js 60

An abstract class for updating geometry entites.

Name | Type | Description
--- | --- | ---

`options`

Object

An object with the following properties:

Name | Type | Description
--- | --- | ---
`entity` | Entity | The entity containing the geometry to be visualized.
`scene` | Scene | The scene where visualization is taking place.
`geometryOptions` | Object | Options for the geometry
`geometryPropertyName` | String | The geometry property name
`observedPropertyNames` | Array.<String> | The entity properties this geometry cares about

### Members

#### readonlyclassificationTypeProperty : Property
DataSources/GeometryUpdater.js 242

Gets or sets the `ClassificationType` Property specifying if this geometry will classify terrain, 3D Tiles, or both when on the ground.

#### readonlydistanceDisplayConditionProperty : Property
DataSources/GeometryUpdater.js 230

Gets or sets the `DistanceDisplayCondition` Property specifying at what distance from the camera that this geometry will be displayed.

#### readonlyentity : Entity
DataSources/GeometryUpdater.js 114

Gets the entity associated with this geometry.

#### readonlyfillEnabled : Boolean
DataSources/GeometryUpdater.js 126

Gets a value indicating if the geometry has a fill component.

#### readonlyfillMaterialProperty : MaterialProperty
DataSources/GeometryUpdater.js 153

Gets the material property used to fill the geometry.

#### readonlygeometryChanged : Boolean
DataSources/GeometryUpdater.js 294

Gets an event that is raised whenever the public properties of this updater change.

#### readonlyhasConstantFill : Boolean
DataSources/GeometryUpdater.js 138

Gets a value indicating if fill visibility varies with simulation time.

#### readonlyhasConstantOutline : Boolean
DataSources/GeometryUpdater.js 177

Gets a value indicating if the geometry has an outline component.

#### readonlyid : String
DataSources/GeometryUpdater.js 102

Gets the unique ID associated with this updater

#### readonlyisClosed : Boolean
DataSources/GeometryUpdater.js 269

Gets a value indicating if the geometry is closed. This property is only valid for static geometry.

#### readonlyisDynamic : Boolean
DataSources/GeometryUpdater.js 256

Gets a value indicating if the geometry is time-varying. If true, all visualization is delegated to the `DynamicGeometryUpdater` returned by GeometryUpdater#createDynamicUpdater.

#### readonlyoutlineColorProperty : Property
DataSources/GeometryUpdater.js 192

Gets the `Color` property for the geometry outline.

#### readonlyoutlineEnabled : Boolean
DataSources/GeometryUpdater.js 165

Gets a value indicating if the geometry has an outline component.

#### readonlyoutlineWidth : Number
DataSources/GeometryUpdater.js 205

Gets the constant with of the geometry outline, in pixels. This value is only valid if isDynamic is false.

#### readonlyshadowsProperty : Property
DataSources/GeometryUpdater.js 218

Gets the property specifying whether the geometry casts or receives shadows from each light source.

### Methods

#### createDynamicUpdater(primitives, groundPrimitives) → DynamicGeometryUpdater
DataSources/GeometryUpdater.js 503

Creates the dynamic updater to be used when GeometryUpdater#isDynamic is true.

Name | Type | Description
--- | --- | ---
`primitives` | PrimitiveCollection | The primitive collection to use.
`groundPrimitives` | PrimitiveCollection | optional The primitive collection to use for ground primitives.

##### Returns:

The dynamic updater used to update the geometry each frame.

##### Throws:

- DeveloperError : This instance does not represent dynamic geometry.

#### createFillGeometryInstance(time) → GeometryInstance
DataSources/GeometryUpdater.js 334

Creates the geometry instance which represents the fill of the geometry.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The time to use when retrieving initial attribute values.

##### Returns:

The geometry instance representing the filled portion of the geometry.

##### Throws:

- DeveloperError : This instance does not represent a filled geometry.

#### createOutlineGeometryInstance(time) → GeometryInstance
DataSources/GeometryUpdater.js 345

Creates the geometry instance which represents the outline of the geometry.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The time to use when retrieving initial attribute values.

##### Returns:

The geometry instance representing the outline portion of the geometry.

##### Throws:

- DeveloperError : This instance does not represent an outlined geometry.

#### destroy()
DataSources/GeometryUpdater.js 361

Destroys and resources used by the object. Once an object is destroyed, it should not be used.

##### Throws:

- DeveloperError : This object was destroyed, i.e., destroy() was called.

#### isDestroyed() → Boolean
DataSources/GeometryUpdater.js 352

Returns true if this object was destroyed; otherwise, false.

##### Returns:

True if this object was destroyed; otherwise, false.

#### isFilled(time) → Boolean
DataSources/GeometryUpdater.js 319

Checks if the geometry is filled at the provided time.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The time for which to retrieve visibility.

##### Returns:

true if geometry is filled at the provided time, false otherwise.

#### isOutlineVisible(time) → Boolean
DataSources/GeometryUpdater.js 307

Checks if the geometry is outlined at the provided time.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The time for which to retrieve visibility.

##### Returns:

true if geometry is outlined at the provided time, false otherwise.